hdu 4198 优先队列

来源:互联网 发布:天涯明月刀ol脸型数据 编辑:程序博客网 时间:2024/06/18 02:51
E - E
Time Limit:1000MS     Memory Limit:32768KB     64bit IO Format:%I64d & %I64u
Submit
 
Status
 
Practice
 
HDU 4198

Description

Captain Clearbeard decided to go to the harbour for a few days so his crew could inspect and repair the ship. Now, a few days later, 
the pirates are getting landsick(Pirates get landsick when they don't get enough of the ships' rocking motion. That's why pirates often
 try to simulate that motion by drinking rum.). Before all of the pirates become too sick to row the boat out of the harbour, captain Clearbeard decided to leave the harbour as quickly as possible. 
Unfortunately the harbour isn't just a straight path to open sea. To protect the city from evil pirates, the entrance of the harbour is a 
kind of maze with drawbridges in it. Every bridge takes some time to open, so it could be faster to take a detour. Your task is to help captain Clearbeard and the fastest way out to open sea. 
The pirates will row as fast as one minute per grid cell on the map. The ship can move only horizontally or vertically on the map. 
Making a 90 degree turn does not take any extra time.

Input

The first line of the input contains a single number: the number of test cases to follow. Each test case has the following format: 
1. One line with three integers, h, w (3 <= h;w <= 500), and d (0 <= d <= 50), the height and width of the map and the delay for 
opening a bridge. 
2.h lines with w characters: the description of the map. The map is described using the following characters: 
―"S", the starting position of the ship. 
―".", water. 
―"#", land. 
―"@", a drawbridge. 
Each harbour is completely surrounded with land, with exception of the single entrance. 

Output

For every test case in the input, the output should contain one integer on a single line: the travelling time of the fastest route to 
open sea. There is always a route to open sea. Note that the open sea is not shown on the map, so you need to move outside of the
 map to reach open sea.

Sample Input

2
6 5 7
#####
#@#.#
#S..#
#...#
4 5 3
#@####.########
###@#
#S#.#
#@..#

Sample Output

16
11

题意:

海盗要脱离大陆,去海边,有@是桥,.        '.'是可以走的路  , #是墙。问最短多少秒可以到。 对于@时需要多花费d时间

思路:

测试的时候发现是个最优解,自然去往bfs想,然而想了半天突然发现有时间的比较。自然想到优先队列,只要想到优先队列,其余的就

比较简单了和普通BFS一样

ac代码:

#include<stdio.h>#include<string.h>#include<queue>using namespace std;char map[501][501];int book[501][501];int h,w,d;int bx,by;int go[4][2]={0,1,1,0,0,-1,-1,0};struct node{  int x;   int y;   int step;   friend bool operator <(node a,node b)   {   return a.step>b.step;//?????;?????;    }};int bfs(int x,int y){     priority_queue<node>Q;      while(!Q.empty())        Q.pop();      book[x][y]=1;        node p,q;        q.x=x;        q.y=y;        q.step=0;        Q.push(q);        while(!Q.empty())        {    p=Q.top();//???;              Q.pop();             for(int i=0;i<4;i++)             {   q=p;                 q.x+=go[i][0];                 q.y+=go[i][1];                 q.step++;                 if(book[q.x][q.y]==1||map[q.x][q.y]=='#')  continue; if(map[q.x][q.y]=='@')  q.step+=d;                 if(q.x<0||q.x>=h||q.y<0||q.y>=w)   return q.step;  if(map[q.x][q.y]=='.'||map[q.x][q.y]=='@') {                    book[q.x][q.y]=1;           Q.push(q);    }  }             }return -1;}int main(){    int t,i,j;    scanf("%d",&t);     while(t--)     {       memset(book,0,sizeof(book));    memset(map,0,sizeof(map));scanf("%d %d %d",&h,&w,&d);         for(i=0;i<h;i++)          {  scanf("%s",map[i]);             for(j=0;j<w;j++)              {   if(map[i][j]=='S')                    {   bx=i;   by=j;    }  }  }  //printf("%d %d",bx,by);   int flag=bfs(bx,by);   printf("%d\n",flag);   } return 0;}


0 0
原创粉丝点击